VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.1#0"; "MSComCtl.OCX"
Begin VB.Form NimNameChange_Main 
   Caption         =   "Nimbus Name change utility"
   ClientHeight    =   11310
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   7650
   LinkTopic       =   "Form1"
   ScaleHeight     =   11310
   ScaleWidth      =   7650
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command_SaveReceivers 
      Caption         =   "Save Receivers"
      Height          =   315
      Left            =   2040
      TabIndex        =   5
      Top             =   10860
      Width           =   1575
   End
   Begin VB.CommandButton Command_SaveProfiles 
      Caption         =   "Save Profiles"
      Height          =   315
      Left            =   300
      TabIndex        =   4
      Top             =   10860
      Width           =   1575
   End
   Begin VB.Frame Frame 
      Caption         =   "R&eceivers"
      Height          =   5085
      Index           =   1
      Left            =   0
      TabIndex        =   2
      Top             =   5700
      Width           =   7575
      Begin MSComctlLib.ListView ListView_Receivers 
         Height          =   4575
         Left            =   120
         TabIndex        =   3
         Top             =   330
         Width           =   7275
         _ExtentX        =   12832
         _ExtentY        =   8070
         View            =   3
         LabelEdit       =   1
         Sorted          =   -1  'True
         LabelWrap       =   -1  'True
         HideSelection   =   0   'False
         FullRowSelect   =   -1  'True
         GridLines       =   -1  'True
         _Version        =   393217
         SmallIcons      =   "ImageList_Small"
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         Appearance      =   1
         NumItems        =   1
         BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            Text            =   "Name"
            Object.Width           =   10583
         EndProperty
      End
   End
   Begin VB.Frame Frame 
      Caption         =   "&Route Profiles"
      Height          =   5685
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   7575
      Begin MSComctlLib.ListView ListView_Profiles 
         Height          =   5265
         Left            =   120
         TabIndex        =   1
         Top             =   270
         Width           =   7275
         _ExtentX        =   12832
         _ExtentY        =   9287
         View            =   3
         LabelEdit       =   1
         Sorted          =   -1  'True
         LabelWrap       =   -1  'True
         HideSelection   =   0   'False
         HideColumnHeaders=   -1  'True
         FullRowSelect   =   -1  'True
         GridLines       =   -1  'True
         _Version        =   393217
         SmallIcons      =   "ImageList_Small"
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         Appearance      =   1
         NumItems        =   1
         BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            Text            =   "Name"
            Object.Width           =   10583
         EndProperty
      End
   End
   Begin MSComctlLib.ImageList ImageList_Small 
      Left            =   5700
      Top             =   360
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   13
      ImageHeight     =   13
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   2
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "NimNameChange_Main.frx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "NimNameChange_Main.frx":025A
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "NimNameChange_Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub Command_SaveProfiles_Click()

  ProfilesSave
  
End Sub

Private Sub Command_SaveReceivers_Click()

  ReceiversSave
  
End Sub

Private Sub Form_Load()

  Dim ListX As ListItem
  Dim Temp%, Slask%

  MyPath = App.Path & "\" & "Project\" ' "C:\DATA\VB\Nimbus2\Nimbus Alarm Server\Project\"
  
  ReceiversLoad
  ProfilesLoad
    
  ListView_Profiles.Sorted = False

  Temp = 0
  While Temp < Profiles
    Set ListX = ListView_Profiles.ListItems.Add(, , Profile(Temp).ProfileName)
    ListX.SmallIcon = IIf(Profile(Temp).Enabled, 1, 2)
    ListX.Tag = Temp
    Temp = Temp + 1
  Wend
  
  ListView_Profiles.Sorted = True
  
  ListView_Receivers.Sorted = False
  
  Temp = 0
  While Temp < Receivers
    Set ListX = ListView_Receivers.ListItems.Add(, , Receiver(Temp).ReceiverName)
    ListX.SmallIcon = IIf(Receiver(Temp).Enabled, 1, 2)
    ListX.Tag = Temp
    Temp = Temp + 1
  Wend
  
  ListView_Receivers.Sorted = True
  
End Sub


Private Sub ListView_Profiles_DblClick()

  Dim ListX As ListItem
  Dim ProfileName$
  Dim Slask%
  
  Set ListX = ListView_Profiles.SelectedItem
  If Not ListX Is Nothing Then
    ProfileName = ListX.Text
    'Profile(ListX.Tag).Enabled = Profile(ListX.Tag).Enabled Xor True
    ProfileName = Trim(InputBox("New Profile Name:", , ProfileName))
    If ProfileName = "" Then
      Exit Sub
    End If
    Slask = 0
    Do While Slask < Profiles
      If Profile(Slask).ProfileName = ProfileName And ListX.Tag <> Slask Then
        MsgBox "A Route Profile with this name already exists.", vbInformation + vbMsgBoxSetForeground
        Exit Do
      End If
      Slask = Slask + 1
    Loop
  End If
  
  If Slask = Profiles Then
    Profile(ListX.Tag).ProfileName = ProfileName
    ListX.Text = ProfileName
  End If

End Sub


Private Sub ListView_Receivers_DblClick()

  Dim ListX As ListItem
  Dim NewReceiverName$, OldReceiverName$
  Dim Slask%
  Dim ReceiverIndex%
  Dim ProfileIndex%
  Dim ProfileReceiverName$
  Dim ReceiverString$
  
  Set ListX = ListView_Receivers.SelectedItem
  If Not ListX Is Nothing Then
    OldReceiverName = ListX.Text
    NewReceiverName = ListX.Text
    NewReceiverName = Trim(InputBox("New Receiver Name:", , NewReceiverName))
    If NewReceiverName = "" Then
      Exit Sub
    End If
    Slask = 0
    Do While Slask < Receivers
      If Receiver(Slask).ReceiverName = NewReceiverName And ListX.Tag <> Slask Then
        MsgBox "A Receiver with this name already exists.", vbInformation + vbMsgBoxSetForeground
        Exit Do
      End If
      Slask = Slask + 1
    Loop
  End If
  
  If Slask = Receivers Then
    Receiver(ListX.Tag).ReceiverName = NewReceiverName
    ListX.Text = NewReceiverName
    ProfileIndex = 0
    Do While ProfileIndex < Profiles
      ReceiverString = ""
      ReceiverIndex = 0
      ProfileReceiverName = Item(Profile(ProfileIndex).ParallellReceivers, ReceiverIndex, Chr$(0))
      While Len(ProfileReceiverName)
        If UCase(ProfileReceiverName) = UCase(OldReceiverName) Then
          ReceiverString = ReceiverString & NewReceiverName & Chr$(0)
        Else
          ReceiverString = ReceiverString & ProfileReceiverName & Chr$(0)
        End If
        ReceiverIndex = ReceiverIndex + 1
        ProfileReceiverName = Item(Profile(ProfileIndex).ParallellReceivers, ReceiverIndex, Chr$(0))
      Wend
      Profile(ProfileIndex).ParallellReceivers = ReceiverString
      ReceiverString = ""
      ReceiverIndex = 0
      ProfileReceiverName = Item(Profile(ProfileIndex).SequentialReceivers, ReceiverIndex, Chr$(0))
      While Len(ProfileReceiverName)
        If UCase(ProfileReceiverName) = UCase(OldReceiverName) Then
          ReceiverString = ReceiverString & NewReceiverName & Chr$(0)
        Else
          ReceiverString = ReceiverString & ProfileReceiverName & Chr$(0)
        End If
        ReceiverIndex = ReceiverIndex + 1
        ProfileReceiverName = Item(Profile(ProfileIndex).SequentialReceivers, ReceiverIndex, Chr$(0))
      Wend
      Profile(ProfileIndex).SequentialReceivers = ReceiverString
      ProfileIndex = ProfileIndex + 1
    Loop
  End If

End Sub


